//+------------------------------------------------------------------+
//|                                                        iK_3D.mq4 |
//|                                                      Ivan Katsko |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Ivan Katsko"
#property link      "ICQ:372739628"
//--------------------------------------------------------------- 1 --
#define NONE 0

extern bool Shift = true;              //    
extern int TrendMode = 1;        
//extern bool MACD = true;             //  MACD   
//extern bool MA = true;               //  MA   
//extern bool Silense = true;          //  Silense   
//extern bool iKTrend = true;          //  iKTrend   
extern int SilenseLevel = 10;        //  /MACD
extern int PeriodMA = 12;            //  /MACD
extern int PeriodStoch = 3;          //  Stochastic
extern double Lots   = 1;            //   .  ("0" -   )
//extern int Discret=1;                //  : 1 -  ; 2 -    ..
extern double Stop   = 0; 
extern double Profit = 0; 
extern int Level     = 10;           //     
extern datetime StartDateTime = D'01.01.2011';  // 
extern datetime FinishDateTime = D'31.12.2011'; // 
extern double Prots  = 0.07;         //   
extern int SlipPage     = 3;         //   -  
 
bool 
     MACD = true,
     MA = true,
     Silense = true,
     iKTrend = true,
     New_Bar=false,                  //    
     End_Bar=false,                  //   
     Cls=false,                      //   
     Work=true,                      //   .
     Opn_R=false,                    //     
     Shift_U=false,                  //    
     Shift_D=false,                  //    
     Scalp_Up,
     TrendUP, TrendDN,               //  , 
     FMStoch, NMStoch, SMStoch,      //  ,     
     AllowBuy, AllowSell,            //  , 
     AllowFindForw, AllowFindBack,   //   , 
     AllowFindTralingStop=false,     //   
     AllowEsc            =false,     //     
     EscStoch            =false,
     EscMACD             =false,
     EscMA               =false,
     EcsSilense          =false,
     EcsSiKTrend         =false,
     Tag_msg1=false,                 //   1
     Tag_msg2=false,                 //   2
     Tag_msg3=true;

string Symb;                         //  . 

static datetime New_Time;

int MaxLength    = 30,               // -  
    NPeriod, NNPeriod;               //   - 

double TakeProfit =10,           //    
       StopLoss   =10,             // SL   
       OpenLevelUP, OpenLevelDN,     //    , 
       StopTradeLevelUP, StopTradeLevelDN, //    , 
       StopTradeUP, StopTradeDN,     //  , 
       algoritm      = NONE,         // : ">0" - "  "; "<0" - "   "
       sum_TP,                       //     
       dirOpen       = NONE,         //   : ">0" - ; "<0" - 
       Trade2        = NONE,         //       1- 
       MACD1        = NONE,          // 
       MACD0        = NONE,          // 
       MA0     = NONE,               // 
       MA1     = NONE,               //
       iK0     = NONE, 
       Silense0= NONE, 
       Silense1= NONE, 
       StochM  = NONE,
       StochM1 = NONE,
       StochS  = NONE,
       ScalpLevel, 
//       now_direction = NONE,         //  : ">0" - ; "<0" - 
//       Level,                        //   SL/TP
//       Discret,                      //  : 1 -  ; 2 -    ..
       New_Open,                     //   
       New_SL,                       //   
       index_1=2,                    //  1  
       index_2;                      //  2  

//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
   Fun_New_Bar();                      //    
//----
   int
      Total,                           //     
      Tip=-1,                          //  .  (B=0,S=1)
      Ticket;                          //  
   datetime 
      Time_Begin,                      //    
      Op_Time;                         //   
   double
      Lot,                             // .    
      Lts,                             // .    
      Min_Lot,                         //   
      Step,                            //    
      Free,                            //   
      One_Lot,                         //   
      Price,                           //   
      SL,                              // SL   
      TP;                              // TP  
   bool
      Ans  =false,                     //    
      Opn_B=false,                     //     Buy
      Opn_S=false;                     //     Sell
      
   Cls  =false;                        //   
   Time_Begin=GetTickCount();          //     
   
//-------------------      --
   if (New_Bar)                        //      
     {
      Tag_msg1=true;
      End_Bar=false;
//      Opn_R=true;
      
      // .
      if(TimeCurrent()<StartDateTime)            //    
        { 
        Alert("   .   .",": ",Symb,", ",Period());
        return;                                  //   start()
        }            
      if (TimeCurrent()>=FinishDateTime)         //  
        { 
        Alert("  .   .",": ",Symb,", ",Period());
        return;                                  //   start()
        }            
      if(Bars < MaxLength)                       //  
        {
         Alert("   .   .",": ",Symb,", ",Period());
         return;                                 //   start()
        }
      if(Work==false)                            //  
        {
         Alert(" .   .",": ",Symb,", ",Period());
         return;                                 //   start()
        }
     }
//-------------------       --

            
   if ((TimeCurrent()-Time[0]-50)>(Period()-1)*60 // 10    
       && Tag_msg1
       ) 
     { 
//      Alert("!   !",": ",Symb,", ",Period());
      Tag_msg1=false;
      End_Bar=true;
     }
   
//-----------------------  
   Symb=Symbol();                               //  ..
   Total=0;                                     //  
   for(int i=1; i<=OrdersTotal(); i++)          //   
     {
      if (OrderSelect(i-1,SELECT_BY_POS)==true) //   
        {                                       //  :
         if (OrderSymbol()!=Symb)continue;      //   . 
         if (OrderType()>1)                     //  
           {
            Alert("  .   .",": ",Symb,", ",Period());
            return;                             //   start()
           }
         Total++;                               //  . 
         if (Total>1)                           //    
           {
            Alert("  .   .",": ",Symb,", ",Period());
            return;                             //   start()
           }
         Ticket =OrderTicket();                 //  . .
         Op_Time=OrderOpenTime();               //   ..
         Tip    =OrderType();                   //   .
         Price  =OrderOpenPrice();              //  . .
         SL     =OrderStopLoss();               // SL  .
         TP     =OrderTakeProfit();             // TP  .
         Lot    =OrderLots();                   //  
        }
     }
     
   if (New_Bar)                                  //    
     {
      if (Total==0)                              //    
         Opn_R=true;                             //   
        else                                     //    
         Opn_R=false;                            //   (  )
     }
      
   if (Total==0)                                 //    
     {
      Cls=false;                                 //   
      Shift_U=false;                             //     
      Shift_D=false;                             //     
      ObjectDelete("New_Open");                  //  
      ObjectDelete("New_SL"); 
//      NextTrade = iCustom(0, 0, "iK_trend_v01.6",PeriodMA,History,VerExtr,4,NextPeriod, 3, 0);   
     }

//----  
   if(MACD)
     {
     MACD0 = iMACD(0,NNPeriod,PeriodMA,PeriodMA*2,9,PRICE_MEDIAN,MODE_MAIN,0);
     MACD1 = iMACD(0,NNPeriod,PeriodMA,PeriodMA*2,9,PRICE_MEDIAN,MODE_MAIN,1); 
     }
   if(MA)
     {
     MA0   = iMA(0,NNPeriod,PeriodMA,0,MODE_EMA,PRICE_MEDIAN,0);
     MA1   = iMA(0,NNPeriod,PeriodMA,0,MODE_EMA,PRICE_MEDIAN,1);    
     }
   if(Silense)
     {  
     Silense0   = iCustom(0, NNPeriod, "Silense",PeriodMA,288, 1, 0);
     Silense1   = iCustom(0, NNPeriod, "Silense",PeriodMA,288, 1, 1);
     }
   if(iKTrend)
     iK0= iCustom(0, NNPeriod, "iK_trend_v01.6",PeriodMA,100,4,4,0, 2, 0);

   StochM = iStochastic(0,NPeriod,5,3,PeriodStoch,MODE_EMA,0,MODE_MAIN,0);
   StochM1 = iStochastic(0,NPeriod,5,3,PeriodStoch,MODE_EMA,0,MODE_MAIN,1);
   StochS = iStochastic(0,NPeriod,5,3,PeriodStoch,MODE_EMA,0,MODE_SIGNAL,0);
   
//----    
   if(AllowEsc && Total==0)
     {AllowEsc=false;
     TrendUP=false;
     TrendDN=false;
     AllowFindForw=false;
     }

//----      
   if(Total==0)
     {
     if((AllowBuy && Bid<StopLoss)
        || (AllowSell && Ask>StopLoss))
       EscStoch=true;
     if(MACD
        &&((MACD0>MACD1 && TrendDN)
         ||(MACD0<MACD1 && TrendUP)
         ||(!TrendUP && !TrendDN && MACD0>MACD1)
         ||(!TrendUP && !TrendDN && MACD0<MACD1)))
       EscMACD=true;
     if(MA
        &&((MA0>MA1 && TrendDN)
         ||(MA0<MA1 && TrendUP)
         ||(!TrendUP && !TrendDN && MA0>MA1)
         ||(!TrendUP && !TrendDN && MA0<MA1)))
       EscMA=true;
     if(Silense
        && Silense0<=Silense1)
     if(iKTrend
        && iK0==0)
       EcsSiKTrend=true;
   
     if(EscStoch
        ||EcsSiKTrend
        ||(EcsSilense
          &&(MACD || MA))
        ||(EscMACD
          && MACD && !MA)
        ||(EscMA
          && !MACD && MA)
        ||(EscMACD && EscMA
          && MACD && MA)
       )
       {FMStoch            =true;
       NMStoch             =false;
       SMStoch             =false;
       TrendUP             =false;
       TrendDN             =false;
       AllowBuy            =false;
       AllowSell           =false;
       AllowFindTralingStop=false;
       EscStoch            =false;
       EscMACD             =false;
       EscMA               =false;
       EcsSilense          =false;
       EcsSiKTrend         =false;
       OpenLevelDN=0.99*Low[0];
       OpenLevelUP=1.01*High[0];
       StopLoss=NONE;
       ObjectDelete("TrendUP");
       ObjectDelete("TrendDN");
       ObjectDelete("OpenLevelUP");
       ObjectDelete("OpenLevelDN");
       ObjectDelete("StopLoss");
       }
     }
     
//----   
//Alert("TrendUP=",TrendUP," TrendDN=",TrendDN," Silense=",Silense," MACD=",MACD," MA=",MA," Silense0=",Silense0);

   if((TrendDN || (!TrendUP && !TrendDN)) 
     && ((MACD && !MA && !Silense && MACD0>MACD1) 
        ||(MA && !MACD && !Silense && MA0>MA1) 
        ||(MACD && MA && !Silense && MACD0>MACD1 && MA0>MA1)
        ||(MACD && !MA && Silense && MACD0>MACD1 && Silense0>Silense1 && Silense0>SilenseLevel)
        ||(!MACD && MA && Silense && MA0>MA1 && Silense0>Silense1 && Silense0>SilenseLevel)
        ||(MACD && MA && Silense && MACD0>MACD1 && MA0>MA1 && Silense0>Silense1 && Silense0>SilenseLevel) 
        ||(iKTrend && !Silense && iK0>0)
        ||(iKTrend && Silense && iK0>0 && Silense0>Silense1 && Silense0>SilenseLevel))) 
     {TrendUP=true;
     TrendDN=false;
     ObjectDelete("TrendUP");
     ObjectCreate("TrendUP",OBJ_VLINE,0,Time[0],0);
     ObjectSet("TrendUP",OBJPROP_COLOR,Green);
     }
     else
     if((TrendUP || (!TrendUP && !TrendDN)) 
       && ((MACD && !MA && !Silense && MACD0<MACD1) 
          ||(MA && !MACD && !Silense && MA0<MA1)
          ||(MACD && MA && !Silense && MACD0<MACD1 && MA0<MA1)
          ||(MACD && !MA && Silense && MACD0<MACD1 && Silense0>Silense1 && Silense0>SilenseLevel)
          ||(!MACD && MA && Silense && MA0<MA1 && Silense0>Silense1 && Silense0>SilenseLevel)
          ||(MACD && MA && Silense && MACD0<MACD1 && MA0<MA1 && Silense0>Silense1 && Silense0>SilenseLevel) 
          ||(iKTrend && !Silense && iK0<0)
          ||(iKTrend && Silense && iK0<0 && Silense0>Silense1 && Silense0>SilenseLevel))) 
       {TrendDN=true;
       TrendUP=false;
       ObjectDelete("TrendDN");
       ObjectCreate("TrendDN",OBJ_VLINE,0,Time[0],0);
       ObjectSet("TrendDN",OBJPROP_COLOR,Red);
       }
       else
       if((MACD && !MA && !Silense && MACD0==MACD1) 
          ||(MA && !MACD && !Silense && MA0==MA1)
          ||(MACD && MA && !Silense && MACD0<MACD1 && MA0>MA1)
          ||(MACD && MA && !Silense && MACD0>MACD1 && MA0<MA1)
          ||(MACD && !MA && Silense && (MACD0==MACD1 || Silense0<=Silense1))
          ||(!MACD && MA && Silense && (MA0==MA1 || Silense0<=Silense1))
          ||(MACD && MA && Silense && ((MACD0<MACD1 && MA0>MA1) || Silense0<=Silense1))
          ||(MACD && MA && Silense && ((MACD0>MACD1 && MA0<MA1) || Silense0<=Silense1))
          ||(iKTrend && !Silense && iK0==0)
          ||(iKTrend && Silense && (iK0==0 || Silense0<Silense1)))
         {TrendUP=false;
         TrendDN=false;
         ObjectDelete("TrendUP");
         ObjectDelete("TrendDN");
         }

//----      
   if(FMStoch                            //  
      && 
      ((TrendUP && StochM>StochS)
       ||
       (TrendDN && StochM<StochS)))
     {NMStoch=true;
     FMStoch=false;
     SMStoch=false;
     }
 
   if(NMStoch                            //  
      &&
      ((TrendUP && StochM<StochS)
       ||
       (TrendDN && StochM>StochS)))
     {SMStoch=true;
     NMStoch=false;
     OpenLevelDN=0.99*Low[0];
     OpenLevelUP=1.01*High[0];
     }
 
   if(SMStoch)                          //  
     {if(TrendUP && StochM<=80 && StochM>StochM1) AllowBuy=true;
        else
        if(TrendDN && StochM>=20 && StochM<StochM1) AllowSell=true;
          else
          {AllowBuy=false;
          AllowSell=false;
          }
     }

//----     
   if(SMStoch && Total==0)
     {if(TrendUP)                         //   BUY
       if(iHighest(NULL,0,MODE_HIGH,3,1)==2
          && !(iLowest(NULL,0,MODE_LOW,3,1)==2)
          && OpenLevelUP>High[iHighest(NULL,0,MODE_HIGH,3,1)])
         {OpenLevelUP=High[iHighest(NULL,0,MODE_HIGH,3,1)];
         StopLoss=OpenLevelUP;
         AllowFindBack=true;
         }
     if(TrendDN)                         //   SELL
       if(iLowest(NULL,0,MODE_LOW,3,1)==2
          && !(iHighest(NULL,0,MODE_HIGH,3,1)==2)
          && OpenLevelDN<Low[iLowest(NULL,0,MODE_LOW,3,1)])
         {OpenLevelDN=Low[iLowest(NULL,0,MODE_LOW,3,1)];
         StopLoss=OpenLevelDN;
         AllowFindBack=true;
         }
     }
     
//----    
   if(AllowFindBack && Total==0)
     {if(TrendUP)
        for(i=3; i<20; i++)
          {
          if(StopLoss>Low[i])
            StopLoss=Low[i];
            else 
            {AllowFindBack=false;
            AllowFindForw=true;
            break;
            }
          }
     if(TrendDN)
        for(i=3; i<20; i++)
          {
          if(StopLoss<High[i])
            {
            StopLoss=High[i];
            }
            else 
            {AllowFindBack=false;
            AllowFindForw=true;
            break;
            }
          }
     }
     
//----     
   if(AllowFindForw && Total==0)
     {if(TrendUP)
        if(StopLoss>Low[0])
          StopLoss=Low[0];
     if(TrendDN)
       if(StopLoss<High[0])
         StopLoss=High[0];
     }
     
//----  
   if(Total==1)
     {
     StopTradeLevelUP=Price+(OpenLevelUP-StopLoss);
     StopTradeLevelDN=Price-(StopLoss-OpenLevelDN);
   
     if(!AllowFindTralingStop)
       {if(Tip==0 && Bid>StopTradeLevelUP)
         {StopLoss=Price + SlipPage*Point;
         AllowFindTralingStop=true;
         AllowFindForw=false;
         }
       if(Tip==1 && Bid<StopTradeLevelDN)
         {StopLoss=Price - SlipPage*Point;
         AllowFindTralingStop=true;
         AllowFindForw=false;
         }
       }
     }
//----  
   if(AllowFindTralingStop)
     {if(Tip==1)                         
       if(iHighest(NULL,0,MODE_HIGH,3,1)==2
          && StopLoss>High[iHighest(NULL,0,MODE_HIGH,3,1)])
         StopLoss=High[iHighest(NULL,0,MODE_HIGH,3,1)];
     if(Tip==0)                       
       if(iLowest(NULL,0,MODE_LOW,3,1)==2
          && StopLoss<Low[iLowest(NULL,0,MODE_LOW,3,1)])
         StopLoss=Low[iLowest(NULL,0,MODE_LOW,3,1)];
     }

//----     
   if(TrendUP)
      {Comment(
              "Opn_R=",Opn_R,"\n",
              "TrendUP=",TrendUP,"\n",
              "NMStoch=",NMStoch,"\n",
              "SMStoch=",SMStoch,"\n",
              "AllowFindForw=",AllowFindForw,"\n",
              "AllowBuy=",AllowBuy,"\n",
              "Opn_B=",Opn_B,"\n",
              "SL=",(Price-StopLoss)/Point
              );
      ObjectDelete("OpenLevelUP");
      ObjectCreate("OpenLevelUP",OBJ_HLINE,0,0,OpenLevelUP);
      ObjectSet("OpenLevelUP",OBJPROP_COLOR,Green);
      
      ObjectDelete("StopLoss");
      ObjectCreate("StopLoss",OBJ_HLINE,0,Time[0],StopLoss);
      ObjectSet("StopLoss",OBJPROP_COLOR,Brown);
      }
      else
      if(TrendDN)
         {Comment(
                 "Opn_R=",Opn_R,"\n",
                 "TrendDN=",TrendDN,"\n",
                 "NMStoch=",NMStoch,"\n",
                 "SMStoch=",SMStoch,"\n",
                 "AllowFindForw=",AllowFindForw,"\n",
                 "AllowSell=",AllowSell,"\n",
                 "Opn_S=",Opn_S,"\n",
                 "SL=",(StopLoss-Price)/Point
                 );
         ObjectDelete("OpenLevelDN");
         ObjectCreate("OpenLevelDN",OBJ_HLINE,0,Time[0],OpenLevelDN);
         ObjectSet("OpenLevelDN",OBJPROP_COLOR,Red);
      
         ObjectDelete("StopLoss");
         ObjectCreate("StopLoss",OBJ_HLINE,0,0,StopLoss);
         ObjectSet("StopLoss",OBJPROP_COLOR,Brown);
         }
         else 
         {Comment("");
         ObjectDelete("OpenLevelUP");
         ObjectDelete("OpenLevelDN");
         ObjectDelete("StopLoss");
         }

//----         
   if((Tip==0                                     //    
       && Bid<StopLoss)    
      ||                                          // 
       (Tip==1                                     //    
       && Ask>StopLoss))    
     {                                           
     Cls = true;                                 //   
     Opn_R=false;                                //       
     }

//----   
   if(Total==0                                    //   ,
     && AllowFindForw                            
     && Opn_R)                                   //       
     {
     if(AllowBuy
       && Ask>OpenLevelUP)
       Opn_B=true;                               //     Buy
     if(AllowSell
       && Bid<OpenLevelDN)
       Opn_S=true;                               //  Sell
     }

//--------------------------------------------------------------- 7 --
   //  
   RefreshRates();                              //  
   Min_Lot=MarketInfo(Symb,MODE_MINLOT);        // . .  
   Free   =AccountFreeMargin();                 //  
   One_Lot=MarketInfo(Symb,MODE_MARGINREQUIRED);//  1 
   Step   =MarketInfo(Symb,MODE_LOTSTEP);       //   
 
   if (Lots > 0)                                //   , 
      Lts =Lots;                                //     
   else                                         // %  
      Lts=MathFloor(Free*Prots/One_Lot/Step)*Step;//  
 
   if(Lts < Min_Lot) Lts=Min_Lot;               //   
   
   if (Lts*One_Lot > Free &&                    //   .
      TimeCurrent()<(Time[0] + 2*60) &&         //     2- 
      Total==0)                                 //    
     {
      Alert("     ", Lts," ",": ",Symb,", ",Period());
      return;                                   //   start()
     }

//--------------------------------------------------------------- 6 --
   //  
   while(Ticket>0)                              //   .
     {
      if(Tip==0 && Cls==true)                  //   Buy..
        {                                       //    
        Alert("  Buy: ",Symb,", ",Period());
        RefreshRates();                        //  
        Ans=OrderClose(Ticket,Lot,Bid,2,Blue);      //  Buy
        if(Ans==true)                         //  :)
          break;                              //    
        if(Fun_Error(GetLastError())==1)      //  
          {
//            Opn_R=false;                        //       
          Opn_R=true;                        //   
          continue;                           //  
          }
        return;                                //   start()
        }
      if(Tip==1 && Cls==true)                  //   Sell..
        {                                       //    
        Alert("  Sell: ",Symb,", ",Period());
        RefreshRates();                        //  
        Ans=OrderClose(Ticket,Lot,Ask,2,Red);      //  Sell
        if(Ans==true)                         //  :)
          break;                              //    
        if(Fun_Error(GetLastError())==1)      //  
          {
//            Opn_R=false;                        //       
          Opn_R=true;                         //   
          continue;                           //  
          }
        return;                                //   start()
        }
      break;                                    //   while
     }
   
//----    
   if(Opn_B)
     {
     if(Stop==0)
       SL=Ask-New_Stop((Ask-StopLoss)/Point)*Point; 
       else 
       if((Ask-StopLoss)/Point>Stop)
         SL=Ask - New_Stop(Stop)*Point;
         else
         SL=StopLoss;
     if(Profit==0)
       if(Shift)
         TP=Ask+100*(Ask-StopLoss);
         else
         TP=Ask+New_Stop(2.5*(Ask-StopLoss)/Point)*Point;
     }
   if(Opn_S)
     {
     if(Stop==0)
       SL=Bid+New_Stop((StopLoss-Bid)/Point)*Point;
       else
       if((StopLoss-Bid)/Point>Stop)
         SL=Bid+New_Stop(Stop)*Point;
         else
         SL=StopLoss;
     if(Profit==0)
       if(Shift)
         TP=Bid-100*(StopLoss-Bid);
         else
         TP=Bid-New_Stop(2.5*(StopLoss-Bid)/Point)*Point;
     }
     
//----  
   while(Opn_R)                                 //   .
     {
      if(Total==0 && Opn_B==true)              //  .  +
        {                                       //  . Buy
        RefreshRates();                        //  
        Alert("  Buy: ",Symb,", ",Period());
        Ticket=OrderSend(Symb,OP_BUY,Lts,Ask,2,SL,TP,0,0,0,Blue);// Buy
        if(Ticket > 0)                        //  :)
          {AllowEsc=true;
          return;                             //   start()
          }
        if(Fun_Error(GetLastError())==1)      //  
          continue;                           //  
        return;                                //   start()
        }
      if(Total==0 && Opn_S==true)              //  .  +
        {                                       //  . Sell
        RefreshRates();                        //  
        Alert("  Sell: ",Symb,", ",Period());
        Ticket=OrderSend(Symb,OP_SELL,Lts,Bid,2,SL,TP,0,0,0,Red);// Sel
        if(Ticket > 0)                        //  :)
          {AllowEsc=true;
          return;                             //   start()
          }
        if(Fun_Error(GetLastError())==1)      //  
          continue;                           //  
        return;                                //   start()
        }
      break;                                    //   while
     }   
//----
   return;                                      //   start()
  }
//-------------------------------------------------------------- 10 --
int Fun_Error(int Error)                        // -  
  {
   switch(Error)
     {                                          //              
      case   4: Alert("  .   ..",": ",Symb,", ",Period());
         Sleep(3000);                           //  
         return(1);                             //   
      case 128: Alert("  ..",": ",Symb,", ",Period());
         return(1);                             //   
      case 130:Alert("  ",": ",Level,", ",Symb,", ",Period());
         if (Point==0.0001) Level++; else Level=Level+10; //    SL/TP
         Opn_R=false;                           //      
//         Sleep(5000);                           //  
         return(1);                             //   
      case 135:Alert(" .   ..",": ",Symb,", ",Period());
         RefreshRates();                        //  
         return(1);                             //   
      case 136:Alert(" .   ..",": ",Symb,", ",Period());
         while(RefreshRates()==false)           //   
            Sleep(1);                           //   
         return(1);                             //   
      case 137:Alert(" .   ..",": ",Symb,", ",Period());
         Sleep(3000);                           //  
         return(1);                             //   
      case 138:Alert("  ..",": ",Symb,", ",Period());
         return(1);                             //   
      case 145:Alert("     .   15.",": ",Symb,", ",Period());
         Cls = false;
//         Sleep(15000);                        //  
         return(1);                             //   
      case 146:Alert("  .  ..",": ",Symb,", ",Period());
         Sleep(500);                            //  
         return(1);                             //   
         //  
      case  2: Alert(" .",": ",Symb,", ",Period());
         return(0);                             //   
      case  5: Alert("  .",": ",Symb,", ",Period());
         Work=false;                            //   
         return(0);                             //   
      case 64: Alert(" .",": ",Symb,", ",Period());
         Work=false;                            //   
         return(0);                             //   
      case 133:Alert(" .",": ",Symb,", ",Period());
         return(0);                             //   
      case 134:Alert("    .",": ",Symb,", ",Period());
         return(0);                             //   
      default: Alert("  ",Error,": ",Symb,", ",Period()); //     
         return(0);                             //   
     }
  }
//-------------------------------------------------------------- 11 --
int New_Stop(int Parametr)                      //  -.
  {
   int Min_Dist=MarketInfo(Symbol(),MODE_STOPLEVEL)+MarketInfo(Symbol(), MODE_SPREAD)+SlipPage;// . 
   if (Parametr < Min_Dist)                     //   .
     {
      Parametr=Min_Dist;                        //  .
     }
   return(Parametr);                            //  
  }
//+------------------------------------------------------------------+
void Fun_New_Bar()                              // -   
  {                                             
   New_Bar=false;                               //   
   if(New_Time!=Time[0])                        //  
     {
      New_Time=Time[0];                         //   
      New_Bar=true;                             //     
     }
  }
//-------------------------------------------------------------- 12 --
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
   Tag_msg1=true;                                  //   1
   New_Time=Time[0];                               //   

   switch (Period())                               //  NextPeriod
      {
       case    1: NPeriod = 5;     NNPeriod = 30;    break;  //  1-  
       case    5: NPeriod = 30;    NNPeriod = 240;   break;  //  5-  
       case   15: NPeriod = 30;    NNPeriod = 240;   break;  //  15- 
       case   30: NPeriod = 240;   NNPeriod = 1440;  break;  //  30- 
       case   60: NPeriod = 240;   NNPeriod = 1440;  break;  //  
       case  240: NPeriod = 1440;  NNPeriod = 10080; break;  //  4- 
       case 1440: NPeriod = 10080; NNPeriod = 43200; break;  //  
       default: break; 
      }
      
   switch (TrendMode)
      {
       case    1: MACD=true;  MA=true;  Silense=false; iKTrend=false;   break;
       case    2: MACD=true;  MA=false; Silense=false; iKTrend=false;   break;
       case    3: MACD=false; MA=true;  Silense=false; iKTrend=false;   break;
       case    4: MACD=true;  MA=true;  Silense=true;  iKTrend=false;   break;
       case    5: MACD=true;  MA=false; Silense=true;  iKTrend=false;   break;
       case    6: MACD=false; MA=true;  Silense=true;  iKTrend=false;   break;
       case    7: MACD=false; MA=false; Silense=false; iKTrend=true;    break;
       case    8: MACD=false; MA=false; Silense=true;  iKTrend=true;    break;
       default: break; 
      }
      
      //    
   int 
      Total,                                       //     
      Ticket,
      Tip=-1;                                      //  .  (B=0,S=1)
   double 
      TP,
      SL,
      Price;                                       //   
      Symb=Symbol();                               //  ..

   for(int i=1; i<=OrdersTotal(); i++)             //   
     {
      if (OrderSelect(i-1,SELECT_BY_POS)==true)    //   
        {                                          //  :
         if (OrderSymbol()!=Symb)continue;         //   . 
         if (OrderType()>1)                        //  
           {
            Alert("  .   .",": ",Symb,", ",Period());
            return;                                //   start()
           }
         Total++;                                  //  . 
         if (Total>1)                              //    
           {
            Alert("  .   .",": ",Symb,", ",Period());
            return;                                //   start()
           }
         Ticket =OrderTicket();                    //  . .
         Tip    =OrderType();                      //   .
         Price  =OrderOpenPrice();                 //  . .
         SL     =OrderStopLoss();                  // SL  .
         TP     =OrderTakeProfit();                // TP  .
        }
     }
  
   if (Level<MarketInfo(Symb,MODE_STOPLEVEL)) 
      Level=MarketInfo(Symb,MODE_STOPLEVEL);       //   SL/TP
//   Discret=1;                                      //   
   
   if (Total==0) Opn_R=false;                      //      

   if (Ticket>0                                    //    
       && !Shift)                            //    
     {
      New_Open=Price;                              //     
      New_SL=SL;                                   //     SL
      Alert(".   . TP=",TP,", SL=",SL,": ",Symb,", ",Period());
     } 
   if (Ticket>0                                    //    
       && Shift)                            //   
     {
         //    
      if (MathAbs(Price-TP)/Point < 500
          && Tip==0)
        TP=Price + New_Stop(TakeProfit+1000)*Point;
         
      if (MathAbs(Price-TP)/Point < 500
          && Tip==1)
        TP=Price - New_Stop(TakeProfit+1000)*Point;
         
      if (OrderModify(Ticket,Price,SL,TP,0))
        {
         Alert(".  . TP=",TP,", SL=",SL,": ",Symb,", ",Period());
        }
        else
        {
         Alert(".   ,  ",GetLastError(),": ",Symb,", ",Period());
        }
        
         //  New_Open  New_SL  
      New_Open=0;
      New_SL=0;
       
      if (Tip==0)                                           //    
        {                                                   //  
         New_Open=Price + New_Stop(TakeProfit)*Point;       //     
         New_SL=SL;                                         //     SL
         if (Bid>New_Open)                                  //     
           {
           New_Open=Bid;                                    //    
           New_SL=New_Open                                  //    
                  -(3*MarketInfo(Symb,MODE_SPREAD)*Point    //     2  
                  +index_2*(New_Open-(Price+(TakeProfit     //  0.1 ()
                  -MarketInfo(Symb, MODE_SPREAD))*Point))); //   
           }
        }
      if (Tip==1)                                           //    
        {                                                   //  
         New_Open=Price - New_Stop(TakeProfit)*Point;       //     
         New_SL=SL;                                         //     SL
         if (Ask<New_Open)                                  //      
           {
            New_Open=Ask;                                   //    
            New_SL=New_Open                                 //    
                   +(3*MarketInfo(Symb,MODE_SPREAD)*Point   //     2  
                   -index_2*(New_Open-(Price-(TakeProfit    //   ()
                   +MarketInfo(Symb, MODE_SPREAD))*Point)));//   
           }
        }
      Alert("  New_Open=",New_Open,", New_SL=",New_SL,": ",Symb,", ",Period());
       
            //      
      ObjectDelete("New_Open"); 
      ObjectCreate("New_Open", OBJ_HLINE, 0 , 0, New_Open);
      ObjectDelete("New_SL"); 
      ObjectCreate("New_SL", OBJ_HLINE, 0 , 0, New_SL);
     }                                                      //   

//----   
   if(!MACD && !MA && !iKTrend)
     {MACD = true; MA = true;}
   if((MACD || MA) && iKTrend)
     iKTrend = false;
   if(MACD)
     {
     MACD0 = iMACD(0,NNPeriod,12,26,9,PRICE_MEDIAN,MODE_MAIN,0);
     MACD1 = iMACD(0,NNPeriod,12,26,9,PRICE_MEDIAN,MODE_MAIN,1); 
     }
   if(MA)
     {
     MA0   = iMA(0,NNPeriod,12,0,MODE_EMA,PRICE_MEDIAN,0);
     MA1   = iMA(0,NNPeriod,12,0,MODE_EMA,PRICE_MEDIAN,1);    
     }
   if(Silense)
     {  
     Silense0   = iCustom(0, NNPeriod, "Silense",PeriodMA,288, 1, 0);
     Silense1   = iCustom(0, NNPeriod, "Silense",PeriodMA,288, 1, 1);
     }
   if(iKTrend)
     iK0= iCustom(0, NNPeriod, "iK_trend_v01.6",PeriodMA,100,4,4,0, 2, 0);

   if((MACD && !MA && !Silense && MACD0>MACD1)
     || (MA && !MACD && !Silense && MA0>MA1)
     || (MACD && MA && !Silense && MACD0>MACD1 && MA0>MA1)
     || (MACD && !MA && Silense && MACD0>MACD1 && Silense0>Silense1 && Silense0>SilenseLevel)
     || (!MACD && MA && Silense && MA0>MA1 && Silense0>Silense1 && Silense0>SilenseLevel)
     || (MACD && MA && Silense && MACD0>MACD1 && MA0>MA1 && Silense0>Silense1 && Silense0>SilenseLevel)
     || (iKTrend && !Silense && iK0>0)
     || (iKTrend && Silense && iK0>0 && Silense0>Silense1 && Silense0>SilenseLevel))
     {TrendUP=true;
     ObjectDelete("TrendUP");
     ObjectCreate("TrendUP",OBJ_VLINE,0,Time[0],0);
     ObjectSet("TrendUP",OBJPROP_COLOR,Green);
     }
     else
     if((MACD && !MA && !Silense && MACD0<MACD1)
       || (MA && !MACD && !Silense && MA0<MA1)
       || (MACD && MA && !Silense && MACD0<MACD1 && MA0<MA1)
       || (MACD && !MA && Silense && MACD0<MACD1 && Silense0>Silense1 && Silense0>SilenseLevel)
       || (!MACD && MA && Silense && MA0<MA1 && Silense0>Silense1 && Silense0>SilenseLevel)
       || (MACD && MA && Silense && MACD0<MACD1 && MA0<MA1 && Silense0>Silense1 && Silense0>SilenseLevel)
       || (iKTrend && !Silense && iK0<0)
       || (iKTrend && Silense && iK0<0 && Silense0>Silense1 && Silense0>SilenseLevel))
       {TrendDN=true;
       ObjectDelete("TrendDN");
       ObjectCreate("TrendDN",OBJ_VLINE,0,Time[0],0);
       ObjectSet("TrendDN",OBJPROP_COLOR,Red);
       }
       else
       {TrendUP=false;
       TrendDN=false;
       ObjectDelete("TrendUP");
       ObjectDelete("TrendDN");
       }

//----      
   StochM = iStochastic(0,NPeriod,5,3,3,MODE_EMA,0,MODE_MAIN,0);
   StochS = iStochastic(0,NPeriod,5,3,3,MODE_EMA,0,MODE_SIGNAL,0);

   if((TrendUP && StochM>StochS)         //   
      ||
      (TrendDN && StochM<StochS))
     {FMStoch=true;
     NMStoch=false;
     SMStoch=false;
     }
 
   if((TrendUP && StochM<StochS)         //   
      ||
      (TrendDN && StochM>StochS))
     {FMStoch=false;
     NMStoch=true;
     SMStoch=false;
     }
   OpenLevelDN=NONE;
   OpenLevelUP=NONE;
//Alert("TrendUP=",TrendUP," TrendDN=",TrendDN," StochM=",StochM," StochS=",StochS," FMStoch=",FMStoch," NMStoch=",NMStoch," SMStoch=",SMStoch); 
   }
  
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
      //    
   int 
      Total,                                       //     
      Tip=-1,                                      //  .  (B=0,S=1)
      Ticket;
   double 
      TP,
      SL,
      Price;                                       //   
      Symb=Symbol();                               //  ..

   for(int i=1; i<=OrdersTotal(); i++)             //   
     {
      if (OrderSelect(i-1,SELECT_BY_POS)==true)    //   
        {                                          //  :
         if (OrderSymbol()!=Symb)continue;         //   . 
         if (OrderType()>1)                        //  
           {
            Alert("  .   .",": ",Symb,", ",Period());
            return;                                //   start()
           }
         Total++;                                  //  . 
         if (Total>1)                              //    
           {
            Alert("  .   .",": ",Symb,", ",Period());
            return;                                //   start()
           }
         Ticket =OrderTicket();                    //  . .
         Tip    =OrderType();                      //   .
         Price  =OrderOpenPrice();                 //  . .
         SL     =OrderStopLoss();                  // SL  .
        }
     }
        
   if (Ticket>0                        //    
       && Shift)                //   
     {
      //----      
      if (Tip==0                       //     ,
          && !(Shift_U||Shift_D))      //   ,
         TP=Ask + New_Stop(TakeProfit)*Point;
         
      if (Tip==1                       //     ,
          && !(Shift_U||Shift_D))      //   ,
         TP=Bid -  New_Stop(TakeProfit)*Point;
        
      //----      
      if (Tip==0                       //     ,
          && (Shift_U||Shift_D))       //  ,
        {
         TP=New_Open + New_Stop(TakeProfit)*Point;
         SL=New_SL;
        }
      if (Tip==1                       //     ,
          && (Shift_U||Shift_D))       //  ,
        {
         TP=New_Open -  New_Stop(TakeProfit)*Point;
         SL=New_SL;
        }
        
      //----      
      if (OrderModify(Ticket,Price,SL,TP,0))
        {
         Alert(".  . TP=",TP,", SL=",SL,": ",Symb,", ",Period());
         return;
        }
         else
        {
         Alert(".   ,  ",GetLastError(),": ",Symb,", ",Period());
        }
     }                                 //   
   ObjectDelete("New_Open"); 
   ObjectDelete("New_SL"); 
   return(0);
  }


